<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'TabsIntro',
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
  data() {
    return {
      baseHarveyUrl: '/nuxt-images/competition/progress-bars/',
      progressBarAltTextBase:
        'Progress bar that shows the current feature capability as ',
    };
  },
  methods: {
    progressBarLegend(value: number) {
      switch (value) {
        case 0:
          return 'little or no capability';
        case 25:
          return 'basic';
        case 50:
          return 'adequate';
        case 75:
          return 'good';
        case 100:
          return 'comprehensive';
        default:
          return null;
      }
    },
  },
});
</script>

<template>
  <div class="tabs-intro">
    <div class="comparisons">
      <div class="comparison">
        <SlpTypography variant="heading5-bold" tag="p">GitLab</SlpTypography>
        <nuxt-img
          v-if="data.gitlab_coverage !== undefined"
          class="slp-mt-8 comparison__img"
          loading="lazy"
          :src="`${baseHarveyUrl}${data.gitlab_coverage}.svg`"
          format="webp"
          quality="99"
        />
      </div>
      <div class="comparison">
        <SlpTypography variant="heading5-bold" tag="p">{{
          data.competitor_product
        }}</SlpTypography>
        <nuxt-img
          v-if="data.competitor_coverage !== undefined"
          class="slp-mt-8 comparison__img"
          loading="lazy"
          :alt="`${progressBarAltTextBase}${progressBarLegend(
            data.competitor_coverage,
          )}`"
          :src="`${baseHarveyUrl}${data.competitor_coverage}.svg`"
          format="webp"
          quality="99"
        />
      </div>
    </div>
    <SlpTypography
      class="tabs-intro__description slp-mb-32"
      variant="heading5"
      tag="h3"
      >{{ data.subheading }}</SlpTypography
    >
    <SlpButton
      class="tabs-intro__button"
      :href="data.maturity_comparison_button?.link || ''"
      :data-ga-name="
        data.maturity_comparison_button?.data_ga_name || 'Read More'
      "
      :data-ga-location="
        data.maturity_comparison_button?.data_ga_location || 'body'
      "
      variant="tertiary"
    >
      <span>{{ data.maturity_comparison_button?.text }}</span>

      <SlpIcon
        icon="gl-chevron-lg-right"
        alt="Chevron Right Icon"
        class="tabs-intro__button-icon"
      />
    </SlpButton>
  </div>
</template>

<style lang="scss" scoped>
.tabs-intro {
  border-bottom: 1px solid $color-surface-200;
  padding-bottom: 32px;
  @media (min-width: $breakpoint-md) {
    border-bottom: 0 solid transparent;
  }
  .comparisons {
    display: flex;
    margin-top: $spacing-24;
    @media (min-width: $breakpoint-md) {
      margin-top: $spacing-32;
    }

    .comparison {
      display: flex;
      flex-direction: column;
      align-items: center;
      &:nth-child(odd) {
        margin-right: $spacing-8;
      }
      &:nth-child(even) {
        margin-left: $spacing-32;
      }
      &__img {
        min-width: 150px;
      }
    }
  }

  &__button {
    padding: 11px 0;
    text-align: left;
    display: block;
    &-icon {
      display: inline-flex;
      top: 2px;
      position: relative;
    }
  }
  &__description {
    margin-top: $spacing-24;
    @media (min-width: $breakpoint-md) {
      margin-top: 40px;
    }
  }
}
</style>
